#define INCL_REXXSAA
#include <rexxsaa.h>
#include <iostream.h>
#include <stdlib.h>

int main( int args, char *argn[] ) {
  LONG      return_code;                 /* interpreter return code    */
  RXSTRING  *argv = new RXSTRING[ args - 1 ];                     /* program argument string    */
  RXSTRING  retstr;                      /* program return value       */
  SHORT     rc;                          /* converted return code      */
  CHAR      return_buffer[250];          /* returned buffer            */
                                         /* build the argument string  */
  CHAR      retval[1];
  retval[0] = '\0';

  int applen = strlen( argn[0] );
  CHAR * app = ( CHAR * )  malloc( applen + 1 );
  strcpy( app, argn[0] );
  app[ applen - 3 ] = 'P';
  app[ applen - 2 ] = 'L';
  app[ applen - 1 ] = 'G';
  if( args > 1 ) {
    for( int i = 0; i < args - 1; i++ )
      MAKERXSTRING( argv[ i ], argn[ i + 1 ], strlen( argn[ i + 1 ] ) );
  } else {
    MAKERXSTRING( argv[0], retval, strlen( retval ) );
  }
                                       /* set up default return      */
  MAKERXSTRING(retstr, return_buffer, sizeof(return_buffer));
  return_code = RexxStart(args,           /* one argument               */
                          argv,        /* argument array             */
                          app, /* REXX procedure name        */
                          NULL,        /* use disk version           */
                          NULL,    /* default address name       */
                          RXCOMMAND,   /* calling as a subcommand    */
                          NULL,        /* no exits used              */
                          &rc,         /* converted return code      */
                          &retstr);    /* returned result            */
                                       /* process return value       */
                                       /* need to return storage?    */

  if (RXSTRPTR(retstr) != return_buffer)
    DosFreeMem(RXSTRPTR(retstr));      /* release the RXSTRING       */

  return return_code;
}
